searchData={"items":[{"type":"module","title":"cowboy_otel_h","doc":"A cowboy stream handler that extracts spans from http headers and starts and ends opentelemetry span.","ref":"cowboy_otel_h.html"},{"type":"function","title":"cowboy_otel_h.data/4","doc":"Does nothing.","ref":"cowboy_otel_h.html#data/4"},{"type":"function","title":"cowboy_otel_h.early_error/5","doc":"Does nothing.","ref":"cowboy_otel_h.html#early_error/5"},{"type":"function","title":"cowboy_otel_h.info/3","doc":"Intercept the response command, and then set the status code span attribute.","ref":"cowboy_otel_h.html#info/3"},{"type":"function","title":"cowboy_otel_h.init/3","doc":"Start the opentelemetry span.","ref":"cowboy_otel_h.html#init/3"},{"type":"function","title":"cowboy_otel_h.terminate/3","doc":"End the opentelemetry span.","ref":"cowboy_otel_h.html#terminate/3"},{"type":"type","title":"cowboy_otel_h.state/0","doc":null,"ref":"cowboy_otel_h.html#t:state/0"},{"type":"module","title":"cowboy_otel_middleware","doc":"A cowboy middleware that attach the cowboy_otel_h span ctx to itself (the request process).","ref":"cowboy_otel_middleware.html"},{"type":"function","title":"cowboy_otel_middleware.execute/2","doc":"Attach span ctx to request process. Also rename span and set http.route attribute if we have bindings.","ref":"cowboy_otel_middleware.html#execute/2"},{"type":"extras","title":"Cowboy opentelemetry plugin","doc":"# Cowboy opentelemetry plugin\n\nAdd `cowboy_otel_h` first to your cowboy stream handlers, it will pick up propagated spans to cowboy,\nand surround the request with a span.\nAlso add `cowboy_otel_middleware` after your `cowboy_router` middlewares, it will attach the created\nspan from the stream process in the process executing middlewares and your cowboy handler, so subspans are connected.\n\n```erlang\n    ProtocolOpts = #{\n        stream_handlers => [cowboy_otel_h, cowboy_stream_h],\n        middlewares => [cowboy_router, cowboy_otel_middleware, cowboy_handler],\n        ...\n    }\n```","ref":"readme.html"},{"type":"extras","title":"Semantic convention - Cowboy opentelemetry plugin","doc":"Goal is to follow https://opentelemetry.io/docs/specs/semconv/http/http-spans/","ref":"readme.html#semantic-convention"},{"type":"extras","title":"Tests - Cowboy opentelemetry plugin","doc":"FIXME: Add test-suite","ref":"readme.html#tests"},{"type":"extras","title":"Release - Cowboy opentelemetry plugin","doc":"FIXME: Add github build  \nFIXME: Make hex release","ref":"readme.html#release"},{"type":"extras","title":"LICENSE","doc":"ISC License\n\nCopyright 2024 Kivra AB\n\nPermission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"license.html"}],"content_type":"text/plain"}